########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_agedtl.4gs/lowlevel.4gl  1.5  Delta: 7/30/90
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(19)    # group identification

    if group_key = "first_row" then
        # insert "on first row" code here
        return
    end if

    if group_key = report_sort then
        # insert "before group of report_sort code here"
        let rpt.sub_total = 0
        let rpt.sub_per1 = 0
        let rpt.sub_per2 = 0
        let rpt.sub_per3 = 0
        let rpt.sub_per4 = 0
        if curs.on_acct_amt != 0
        then
            let rpt.on_acct_amt = curs.on_acct_amt
            let rpt.heading = "On Account"
            let rpt.sub_per1 = curs.on_acct_amt
            let rpt.tot_per1 = rpt.tot_per1 + curs.on_acct_amt
        else
            let rpt.on_acct_amt = null
            let rpt.heading = null
        end if
        return
    end if

    if group_key = "inv_no" then
        # insert "before group of inv_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#

    let rpt.per1 = null
    let rpt.per2 = null
    let rpt.per3 = null
    let rpt.per4 = null
    let rpt.inv_date = curs.inv_date
    let rpt.balance = curs.balance
    let rpt.due_date = curs.due_date
    let rpt.cust_code = curs.cust_code
    let rpt.bus_name = curs.bus_name
    let rpt.phone = curs.phone
    let rpt.po_no = curs.po_no
    let rpt.inv_no = curs.inv_no
    case
        when report_sort = "bus_name, cust_code"
             let rpt.order_group = curs.bus_name,",",curs.cust_code
        otherwise
             let rpt.order_group = curs.cust_code
    end case
    if m_rcntrc.age_datetype = "I"
    then
        let rpt.out_date = curs.inv_date
    else
        let rpt.out_date = curs.due_date
    end if

    if curs.balance is null then return end if

    case
        when rpt.aging_date - rpt.out_date <= m_rcntrc.age_per1
            let rpt.per1 = curs.balance
            let rpt.sub_per1 = rpt.sub_per1 + curs.balance
            let rpt.tot_per1 = rpt.tot_per1 + curs.balance
            exit case
        when rpt.aging_date - rpt.out_date <= m_rcntrc.age_per2
            let rpt.per2 = curs.balance
            let rpt.sub_per2 = rpt.sub_per2 + curs.balance
            let rpt.tot_per2 = rpt.tot_per2 + curs.balance
            exit case
        when rpt.aging_date - rpt.out_date <= m_rcntrc.age_per3
            let rpt.per3 = curs.balance
            let rpt.sub_per3 = rpt.sub_per3 + curs.balance
            let rpt.tot_per3 = rpt.tot_per3 + curs.balance
            exit case
        otherwise
            let rpt.per4 = curs.balance
            let rpt.sub_per4 = rpt.sub_per4 + curs.balance
            let rpt.tot_per4 = rpt.tot_per4 + curs.balance
            exit case
    end case

    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(19)    # group identification

    if group_key = report_sort then
        # insert "after group of cust_code" code here
        let rpt.sub_total = rpt.sub_per1 + rpt.sub_per2 + rpt.sub_per3 + rpt.sub_per4
        return
    end if

    if group_key = "inv_no" then
        # insert "after group of inv_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        let rpt.tot_total = rpt.tot_per1 + rpt.tot_per2 + rpt.tot_per3 + rpt.tot_per4
        return
    end if

end function
# after_group()


