#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_agedtl.4gs/report.4gl  1.8  Delta: 7/30/90
#####################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
    define
        rpt record                  # record for the report
            main_heading char(35),
            order_group char(37),
            inv_date like stropend.inv_date,
            balance like stropend.balance,
            due_date like stropend.due_date,
            co_name like stxcntrc.co_name,
            aging_date date,
            date_heading char(12),
            per1_heading like strcntrc.age_dsc1,
            per2_heading like strcntrc.age_dsc2,
            per3_heading like strcntrc.age_dsc3,
            per4_heading like strcntrc.age_dsc4,
            cust_code like strcustr.cust_code,
            bus_name like strcustr.bus_name,
            phone like strcustr.phone,
            po_no like stropend.po_no,
            heading char(10),
            on_acct_amt like strcustr.on_acct_amt,
            inv_no like stropend.inv_no,
            out_date date,
            per1 like stropend.balance,
            per2 like stropend.balance,
            per3 like stropend.balance,
            per4 like stropend.balance,
            sub_total like stropend.balance,
            sub_per1 like stropend.balance,
            sub_per2 like stropend.balance,
            sub_per3 like stropend.balance,
            sub_per4 like stropend.balance,
            tot_total like stropend.balance,
            tot_per1 like stropend.balance,
            tot_per2 like stropend.balance,
            tot_per3 like stropend.balance,
            tot_per4 like stropend.balance
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.order_group, rpt.inv_no

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.main_heading    
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "Age by: ", rpt.date_heading,
                column  29, "Aging Date: ",
                column  41, rpt.aging_date using "mm/dd/yy"
            print
            print
                column   1, "Invoice",
                column   9, rpt.date_heading,
                column  21, rpt.per1_heading,
                column  36, rpt.per2_heading,
                column  51, rpt.per3_heading,
                column  65, rpt.per4_heading
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.main_heading;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.order_group
            need 4 lines
            print
                column   1, rpt.cust_code clipped,
                            " ","-"," ",rpt.bus_name 
            print
                column  10, "Phone",
                column  22, rpt.phone
            if
                rpt.po_no is not null
            then
                print
                    column  10, "P.O. Number",
                    column  23, rpt.po_no
            end if

            if
                rpt.heading is not null
             or rpt.on_acct_amt is not null
            then
                print
                    column  10, rpt.heading,
                    column  22, rpt.on_acct_amt using "---,---,---.&&"
            end if
            print

        on every row
            if
                rpt.inv_no is not null
             or rpt.out_date is not null
             or rpt.per1 is not null
             or rpt.per2 is not null
             or rpt.per3 is not null
             or rpt.per4 is not null
            then
                print
                    column   1, rpt.inv_no,
                    column  12, rpt.out_date using "mm/dd/yy",
                    column  22, rpt.per1 using "---,---,---.&&",
                    column  37, rpt.per2 using "---,---,---.&&",
                    column  52, rpt.per3 using "---,---,---.&&",
                    column  67, rpt.per4 using "---,---,---.&&"
            end if

        after group of rpt.order_group
            need 3 lines
            print
                column  23, "-------------",
                column  38, "-------------",
                column  53, "-------------",
                column  68, "-------------"
            print
                column   1, "Total ",
                column   7, rpt.sub_total using "---,---,---.&&",
                column  22, rpt.sub_per1 using "---,---,---.&&",
                column  37, rpt.sub_per2 using "---,---,---.&&",
                column  52, rpt.sub_per3 using "---,---,---.&&",
                column  67, rpt.sub_per4 using "---,---,---.&&"
            print

        on last row
            need 7 lines
            print
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"
            print
                column   1, "Aging Totals:"
            print
            print
                column  16, "Total",
                column  21, rpt.per1_heading,
                column  36, rpt.per2_heading,
                column  51, rpt.per3_heading,
                column  65, rpt.per4_heading
            print
                column   8, "-------------",
                column  23, "-------------",
                column  38, "-------------",
                column  53, "-------------",
                column  68, "-------------"
            print
                column   7, rpt.tot_total using "---,---,---.&&",
                column  22, rpt.tot_per1 using "---,---,---.&&",
                column  37, rpt.tot_per2 using "---,---,---.&&",
                column  52, rpt.tot_per3 using "---,---,---.&&",
                column  67, rpt.tot_per4 using "---,---,---.&&"

end report
# report1()

