#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_agesum.4gs/report.4gl  1.5  Delta: 7/30/90
#####################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            heading char(35),
            order_group char(37),
            inv_date like stropend.inv_date,
            balance like stropend.balance,
            due_date like stropend.due_date,
            co_name like stxcntrc.co_name,
            aging_date date,
            date_heading char(8),
            per1_heading like strcntrc.age_dsc1,
            per2_heading like strcntrc.age_dsc2,
            per3_heading like strcntrc.age_dsc3,
            per4_heading like strcntrc.age_dsc4,
            cust_code like strcustr.cust_code,
            bus_name like strcustr.bus_name,
            inv_no like stropend.inv_no,
            out_date date,
            sub_total like stropend.balance,
            sub_per1 like stropend.balance,
            sub_per2 like stropend.balance,
            sub_per3 like stropend.balance,
            sub_per4 like stropend.balance,
            tot_total like stropend.balance,
            tot_per1 like stropend.balance,
            tot_per2 like stropend.balance,
            tot_per3 like stropend.balance,
            tot_per4 like stropend.balance
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80


    order external by rpt.order_group, rpt.inv_no

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "Age by: ", rpt.date_heading,
                column  29, "Aging Date: ",
                column  41, rpt.aging_date using "mm/dd/yy"
            print
            print
                column  15, "Total",
                column  21, rpt.per1_heading,
                column  36, rpt.per2_heading,
                column  51, rpt.per3_heading,
                column  66, rpt.per4_heading
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.heading
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
        before group of rpt.order_group
            print
                column   1, rpt.cust_code,
                            " ", "-" clipped,
                            " ", rpt.bus_name
        after group of rpt.order_group
            need 2 lines
            print
                column   6, rpt.sub_total using "---,---,---.&&",
                column  22, rpt.sub_per1 using "---,---,---.&&",
                column  37, rpt.sub_per2 using "---,---,---.&&",
                column  52, rpt.sub_per3 using "---,---,---.&&",
                column  67, rpt.sub_per4 using "---,---,---.&&"
            print

        on last row
            need 7 lines
            print
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"
            print
                column   1, "Aging Totals:"
            print
            print
                column  15, "Total",
                column  21, rpt.per1_heading,
                column  36, rpt.per2_heading,
                column  51, rpt.per3_heading,
                column  66, rpt.per4_heading
            print
                column   7, "-------------",
                column  23, "-------------",
                column  38, "-------------",
                column  53, "-------------",
                column  68, "-------------"
            print
                column   6, rpt.tot_total using "---,---,---.&&",
                column  22, rpt.tot_per1 using "---,---,---.&&",
                column  37, rpt.tot_per2 using "---,---,---.&&",
                column  52, rpt.tot_per3 using "---,---,---.&&",
                column  67, rpt.tot_per4 using "---,---,---.&&"

end report
# report1()
