########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_arjrnl.4gs/report.4gl  1.9  Delta: 6/22/90
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            debit_credit like stgactvd.debit_credit,
            co_name char(30),
            start_date date,
            end_date date,
            doc_no like stxtranr.doc_no,
            doc_date like stxtranr.doc_date,
#           doc_desc like stxtranr.doc_desc,
            inv_chk_no like strtranr.inv_chk_no,
            acct_no like stgactvd.acct_no,
            department like stgactvd.department,
            acct_desc like stxchrtr.acct_desc,
            amount like stgactvd.amount,
            crdr char(2),
            cust_code like stxtranr.ref_code,
            bus_name like strcustr.bus_name
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.doc_no, rpt.acct_no

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Accounts Receivable Journal"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column  26, "Between ",
                column  34, rpt.start_date using "mm/dd/yy",
                column  43, "and ",
                column  47, rpt.end_date using "mm/dd/yy"
            print
            print
                column   1, "Document",
                column  13, "Date",
                column  23, "Invoice No",
                column  35, "Customer Code - Customer Business Name"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Accounts Receivable Journal";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.doc_no
            print
                column   1, rpt.doc_no using "<<<<<<<<",
                column  13, rpt.doc_date using "mm/dd/yy",
                column  23, rpt.inv_chk_no,
                column  35, rpt.cust_code clipped,
                            " - ", rpt.bus_name

        after group of rpt.doc_no
            print

        on every row
            print
                column  21, rpt.acct_no using "######",
                column  27, "-",
                column  28, rpt.department,
                column  35, rpt.acct_desc,
                column  62, rpt.amount using "---------.&&",
                column  77, rpt.crdr

        on last row
            need 4 lines
            print
                column   1, "========================================",
                column  41, "========================================"
            print
            print
                column  18, "Total Debits",
                column  46, "Total Credits"
            print
                column  13, sum( rpt.amount )
                            where rpt.crdr = "DB"
                            using "((,(((,(((,(((.&&)",
                column  42, sum( rpt.amount )
                            where rpt.crdr = "CR"
                            using "((,(((,(((,(((.&&)"


end report
# report1()

