##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_crjrnl.4gs/report.4gl  1.5  Last Delta: 10/24/89
##############################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            debit_credit like stgactvd.debit_credit,
            co_name like stxcntrc.co_name,
            start_date date,
            end_date date,
            doc_no like stxtranr.doc_no,
            doc_date like stxtranr.doc_date,
            doc_desc like stxtranr.doc_desc,
            inv_chk_no like strtranr.inv_chk_no,
            acct_no like stgactvd.acct_no,
            department like stgactvd.department,
            acct_desc like stxchrtr.acct_desc,
            amount like stgactvd.amount,
            crdr char(2)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.doc_no, rpt.acct_no

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Cash Receipts Journal"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column  22, "Between ",
                column  30, rpt.start_date using "mm/dd/yy",
                column  40, "and ",
                column  44, rpt.end_date using "mm/dd/yy"
            print
            print
                column   1, "Document",
                column  13, "Date",
                column  23, "Check No",
                column  36, "Reference"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Cash Receipts Journal";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.doc_no
            need 2 lines
            print
            print
                column   1, rpt.doc_no using "<<<<<<<<",
                column  13, rpt.doc_date using "mm/dd/yy",
                column  23, rpt.inv_chk_no,
                column  36, rpt.doc_desc

        on every row
            print
                column  23, rpt.acct_no using "######",
                column  29, "-",
                column  30, rpt.department,
                column  35, rpt.acct_desc,
                column  62, rpt.amount using "---------.&&",
                column  77, rpt.crdr

        on last row
            need 4 lines
            print
                column   1, "========================================",
                column  41, "========================================"
            print
            print
                column  18, "Total Debits",
                column  46, "Total Credits"
            print
                column  13, sum( rpt.amount )
                            where rpt.crdr = "DB"
                            using "((,(((,(((,(((.&&)",
                column  42, sum( rpt.amount )
                            where rpt.crdr = "CR"
                            using "((,(((,(((,(((.&&)"

end report
# report1()

