########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_invce.4gs/lowlevel.4gl  1.8  Delta: 8/31/90
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20),   # group identification
        shipcity    like strshipr.city,
        shipstate    like strshipr.state,
        shipzip    like strshipr.zip,
        shipcountry    like strshipr.country

    if group_key = "first_row" then
        # insert "on first row" code here
        return
    end if

    if group_key = "doc_no" then
        # insert "before group of doc_no" code here
        let page_counter = 0
        let rpt.doc_no = curs.doc_no
        let rpt.po_no = curs.po_no
        let rpt.inv_date = curs.inv_date
        if beg_inv is null
        then
            let rpt.inv_no = curs.inv_no
        else
            let rpt.inv_no = beg_inv
            update strinvce set (strinvce.inv_no) = (rpt.inv_no) where
                 strinvce.doc_no = rpt.doc_no
        end if
        let rpt.terms_desc = curs.terms_desc
        let rpt.file_type = curs.file_type
        case
            when rpt.file_type = "C"
                let rpt.file_desc = "Credit Memo No.:"
            when rpt.file_type = "D"
                let rpt.file_desc = " Debit Memo No.:"
            otherwise
                let rpt.file_desc = "    Invoice No.:"
        end case
        let rpt.city = curs.city
        let rpt.state = curs.state
        let rpt.zip = curs.zip
        let rpt.country = curs.country
        let rpt.bus_name = curs.bus_name
        let rpt.address1 = curs.address1
        let rpt.address2 = curs.address2
        let rpt.cust_code = curs.cust_code
        let sub_total = 0
        let rpt.billadd3 = rpt.city clipped, " ", rpt.state clipped, " ",
                           rpt.zip clipped
        let rpt.billcountry = rpt.country clipped
        call shipaddr(curs.cust_code,curs.ship_to_code) returning
                    rpt.shipbus_name, rpt.shipadd1, rpt.shipadd2,
                    shipcity, shipstate, shipzip, shipcountry
        let rpt.shipadd3 = shipcity clipped, " ", shipstate clipped, " ",
                           shipzip clipped
        let rpt.shipcountry = shipcountry
    end if
end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    define
          tmp_qty char(14)   # temporary storage for returning variable

    let page_counter = page_counter + 1
    let rpt.page_no = (page_counter/33) + 1
    let rpt.line_no = curs.line_no
    let rpt.amount = curs.amount
    let rpt.debit_credit = curs.debit_credit
    let rpt.quantity = curs.quantity
    if rpt.quantity is not null
    then
        call dec_to_str(rpt.quantity) returning tmp_qty
        let rpt.char_qty = tmp_qty clipped
        call make_int(rpt.char_qty) returning tmp_qty
        let rpt.char_qty = tmp_qty clipped
    else
        let rpt.char_qty = "        "
    end if
    let rpt.pack = curs.pack
    let rpt.item_no = curs.item_no
    let rpt.description = curs.description
    let rpt.price = curs.price
    let rpt.extension = credit_amount(rpt.debit_credit,rpt.amount)
    let sub_total = rpt.extension + sub_total
    let rpt.sales_tmp = null
    let rpt.misc_tmp = null
    let rpt.frght_tmp = null
    let rpt.tax_tmp = null
    let rpt.ar_tmp = null
    let rpt.inv_note = "CONTINUED ON NEXT PAGE"
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

if group_key = "doc_no"
then
    # insert "after group of doc_no" code here
    if (page_counter mod 33) = 0
    then
      let rpt.line_no = null
      let rpt.amount = null
      let rpt.debit_credit = null
      let rpt.quantity = null
      let rpt.pack = null
      let rpt.item_no = null
      let rpt.description = null
      let rpt.price = null
      let rpt.extension = null
      call ml_output()
      let page_counter = page_counter + 1
      let rpt.page_no = (page_counter/33) + 1
      let rpt.line_no = curs.line_no
      let rpt.amount = curs.amount
      let rpt.debit_credit = curs.debit_credit
      let rpt.quantity = curs.quantity
      let rpt.pack = curs.pack
      let rpt.item_no = curs.item_no
      let rpt.description = curs.description
      let rpt.price = curs.price
      let rpt.extension = credit_amount(rpt.debit_credit,rpt.amount)
    end if
    let rpt.disc_amount = curs.disc_amount
    let rpt.disc_debit_credit = curs.disc_debit_credit
    let rpt.misc_amount = curs.misc_amount
    let rpt.misc_debit_credit = curs.misc_debit_credit
    let rpt.tax_amount = curs.tax_amount
    let rpt.tax_debit_credit = curs.tax_debit_credit
    let rpt.frght_amount = curs.frght_amount
    let rpt.frght_debit_credit = curs.frght_debit_credit
    let rpt.ar_amount = curs.ar_amount
    let rpt.ar_debit_credit = curs.ar_debit_credit
    let rpt.sales_tmp = sub_total
    let rpt.misc_tmp = credit_amount(rpt.misc_debit_credit,rpt.misc_amount)
    let rpt.frght_tmp = credit_amount(rpt.frght_debit_credit,rpt.frght_amount)
    let rpt.tax_tmp = credit_amount(rpt.tax_debit_credit,rpt.tax_amount)
    let rpt.ar_tmp = debit_amount(rpt.ar_debit_credit,rpt.ar_amount)
    let rpt.inv_note = curs.inv_note
    if beg_inv is not null
    then
       let beg_inv = beg_inv + 1
    end if
    return
end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()


#######################################################################
function shipaddr(cust_code, shipcode)
#######################################################################
#
#
#

define
    cust_code like strshipr.cust_code,
    shipcode like strshipr.ship_to_code,
    bus      like strshipr.bus_name,
    addr1    like strshipr.address1,
    addr2    like strshipr.address2,
    city    like strshipr.city,
    state    like strshipr.state,
    zip    like strshipr.zip,
    country    like strshipr.country

    select strshipr.bus_name, strshipr.address1, strshipr.address2,
           strshipr.city, strshipr.state, strshipr.zip, strshipr.country
        into bus, addr1, addr2, city, state, zip, country
            from strshipr
                where cust_code = strshipr.cust_code and
                      shipcode = strshipr.ship_to_code

    if sqlca.sqlcode != 0
    then
        let bus = rpt.bus_name
        let addr1 = rpt.address1
        let addr2 = rpt.address2
        let city = rpt.city
        let state = rpt.state
        let zip = rpt.zip
        let country = rpt.country
        let sqlca.sqlcode = 0
    end if

    return bus, addr1, addr2, city, state, zip, country

end function
# shipaddr()

#######################################################################
function credit_amount(debit_credit, amount)
#######################################################################
#
# this function is used to change the amount to a negative if the
#     the line is not a credit type
#
    define
        debit_credit char(2),
        amount       like strinvcd.amount

    if debit_credit != "CR" and rpt.file_type != "C"
    then
        let amount = amount * -1
    end if
    if debit_credit = "CR" and rpt.file_type = "C"
    then
        let amount = amount * -1
    end if
    return amount
end function
# credit_amount()

#######################################################################
function debit_amount(debit_credit, amount)
#######################################################################
#
# this function is used to change the amount to a negative if the
#    increase with a credit field is not the same as the debit_credit
#    field.
#
    define
        debit_credit char(2),
        amount       like strinvcd.amount

    if debit_credit != "DB" and rpt.file_type != "C"
    then
        let amount = amount * -1
    end if
    if debit_credit = "DB" and  rpt.file_type = "C"
    then
        let amount = amount * -1
    end if
    return amount
end function
# debit_amount()
