##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_invce.4gs/midlevel.4gl  1.5  Last Delta: 6/20/90
##############################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    let quote = "\""

    let ct.sel_join = "strinvce.doc_no = strinvcd.doc_no and ",
                      "strinvce.posted != ", quote, "Y", quote, " and ",
                      "strinvcd.line_no > 0 and ",
                      "strinvce.cust_code = strcustr.cust_code and ",
                      "strtermr.terms_code = strinvce.terms_code"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    call sel_inv() returning ct.sel_filter
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "strinvce.doc_no, strinvcd.line_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from strinvce, outer strinvcd, outer strcustr, outer strtermr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    whenever error continue
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    define
        valid_inv smallint  #boolean

    let valid_inv = true

    call sel_wind()
    display "Enter a starting invoice or credit/debit memo number to print"
      at 5,4
    display "on printed invoices and memos.  Entering a new starting number"
      at 6,4
    display "will overwrite any previously assigned document numbers."
      at 7,4
    display "If this field is left blank, any invoices/memos that were"  
      at 8,4
    display "previously assigned a number will be printed with that number."
      at 9,4
    display "Invoices/memos that have not had a number assigned will be"
      at 10,4
    display "printed without an invoice or memo number."
      at 11,4
    while valid_inv
        let valid_inv = false
        whenever error continue
            prompt " Enter Starting Invoice No.: " for beg_inv
        whenever error call error_handler
        if status != 0
        then 
            let status = 0
            let valid_inv = true
            call fg_err(1) #invalid invoice number
        end if
    end while
    close window selwin

    let ct.sel_stmt =
        "select ",
            "strinvcd.line_no, ",
            "strinvce.file_type, ",
            "strinvce.ship_to_code, ",
            "strcustr.city, ",
            "strcustr.state, ",
            "strcustr.zip, ",
            "strcustr.country, ",
            "strinvce.disc_amount, ",
            "strinvce.disc_debit_credit, ",
            "strinvce.misc_amount, ",
            "strinvce.misc_debit_credit, ",
            "strinvce.tax_amount, ",
            "strinvce.tax_debit_credit, ",
            "strinvce.frght_amount, ",
            "strinvce.frght_debit_credit, ",
            "strinvce.ar_amount, ",
            "strinvce.ar_debit_credit, ",
            "strinvcd.amount, ",
            "strinvcd.debit_credit, ",
            "strinvce.inv_date, ",
            "strinvce.inv_no, ",
            "strcustr.bus_name, ",
            "strcustr.address1, ",
            "strcustr.address2, ",
            "strinvce.doc_no, ",
            "strinvce.cust_code, ",
            "strinvce.po_no, ",
            "strtermr.terms_desc, ",
            "strinvcd.quantity, ",
            "strinvcd.pack, ",
            "strinvcd.item_no, ",
            "strinvcd.description, ",
            "strinvcd.price, ",
            "strinvce.inv_note ",
        "from strinvce, outer strinvcd, outer strcustr, outer strtermr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    whenever error continue
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    whenever error call error_handler
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.line_no = curs_next.line_no
    let curs.file_type = curs_next.file_type
    let curs.ship_to_code = curs_next.ship_to_code
    let curs.city = curs_next.city
    let curs.state = curs_next.state
    let curs.zip = curs_next.zip
    let curs.country = curs_next.country
    let curs.disc_amount = curs_next.disc_amount
    let curs.disc_debit_credit = curs_next.disc_debit_credit
    let curs.misc_amount = curs_next.misc_amount
    let curs.misc_debit_credit = curs_next.misc_debit_credit
    let curs.tax_amount = curs_next.tax_amount
    let curs.tax_debit_credit = curs_next.tax_debit_credit
    let curs.frght_amount = curs_next.frght_amount
    let curs.frght_debit_credit = curs_next.frght_debit_credit
    let curs.ar_amount = curs_next.ar_amount
    let curs.ar_debit_credit = curs_next.ar_debit_credit
    let curs.amount = curs_next.amount
    let curs.debit_credit = curs_next.debit_credit
    let curs.inv_date = curs_next.inv_date
    let curs.inv_no = curs_next.inv_no
    let curs.bus_name = curs_next.bus_name
    let curs.address1 = curs_next.address1
    let curs.address2 = curs_next.address2
    let curs.doc_no = curs_next.doc_no
    let curs.cust_code = curs_next.cust_code
    let curs.po_no = curs_next.po_no
    let curs.terms_desc = curs_next.terms_desc
    let curs.quantity = curs_next.quantity
    let curs.pack = curs_next.pack
    let curs.item_no = curs_next.item_no
    let curs.description = curs_next.description
    let curs.price = curs_next.price
    let curs.inv_note = curs_next.inv_note
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true

    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Account Receivable Invoice"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
end function
# ml_defaults()

