#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_invce.4gs/report.4gl  1.8  Delta: 5/7/90
#####################################################################

#####################################################################
# This report format is designed to fit on form number 091336 from
# Deluxe Computer Forms (phone 1-800-328-0304).
# Use FourGen Accounting code C06798 when ordering.
#####################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            file_desc char(16),
            line_no like strinvcd.line_no,
            file_type like strinvce.file_type,
            ship_to_code like strinvce.ship_to_code,
            city like strcustr.city,
            state like strcustr.state,
            zip like strcustr.zip,
            country like strcustr.country,
            disc_amount like strinvce.disc_amount,
            disc_debit_credit like strinvce.disc_debit_credit,
            misc_amount like strinvce.misc_amount,
            misc_debit_credit like strinvce.misc_debit_credit,
            tax_amount like strinvce.tax_amount,
            tax_debit_credit like strinvce.tax_debit_credit,
            frght_amount like strinvce.frght_amount,
            frght_debit_credit like strinvce.frght_debit_credit,
            ar_amount like strinvce.ar_amount,
            ar_debit_credit like strinvce.ar_debit_credit,
            amount like strinvcd.amount,
            debit_credit like strinvcd.debit_credit,
            inv_date like strinvce.inv_date,
            inv_no like strinvce.inv_no,
            page_no smallint,
            bus_name like strcustr.bus_name,
            shipbus_name char(30),
            address1 like strcustr.address1,
            shipadd1 char(30),
            address2 like strcustr.address2,
            shipadd2 char(30),
            billadd3 char(35),
            shipadd3 char(35),
            doc_no like strinvce.doc_no,
            cust_code like strinvce.cust_code,
            po_no like strinvce.po_no,
            terms_desc like strtermr.terms_desc,
            billcountry char(20),
            shipcountry char(20),
            quantity like strinvcd.quantity,
            char_qty char(8),
            pack like strinvcd.pack,
            item_no like strinvcd.item_no,
            description like strinvcd.description,
            price like strinvcd.price,
            extension like strinvcd.amount,
            sales_tmp like strinvce.ar_amount,
            disc_tmp like strinvce.disc_amount,
            misc_tmp like strinvce.misc_amount,
            tax_tmp like strinvce.tax_amount,
            frght_tmp like strinvce.frght_amount,
            ar_tmp like strinvce.ar_amount,
            inv_note like strinvce.inv_note
        end record,
        last_trlr record
            sales_tmp like strinvce.ar_amount,
            inv_note like strinvce.inv_note,
            misc_tmp like strinvce.misc_amount,
            tax_tmp like strinvce.tax_amount,
            frght_tmp like strinvce.frght_amount,
            ar_tmp like strinvce.ar_amount
        end record,
        after_group smallint,       # boolean: after group flag
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     0
        bottom margin  0
        left margin    0
        right margin   80
        page length    66

    order external by rpt.doc_no, rpt.line_no

    format
        page header
            print
            print
            print
            print
                column  63, rpt.inv_date;
                let scratch = rpt.page_no using "#"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
            print
            print
                column  54, rpt.file_desc,
                column  71, rpt.inv_no
            print
            print
            print
            print
                column   8, rpt.bus_name,
                column  50, rpt.shipbus_name
            print
                column   8, rpt.address1,
                column  50, rpt.shipadd1
            print
                column   8, rpt.address2,
                column  50, rpt.shipadd2
            print
                column   8, rpt.billadd3,
                column  50, rpt.shipadd3
            print
                column   8, rpt.billcountry,
                column  50, rpt.shipcountry
            print
            print
            print
            print
                column   9, rpt.inv_date,
                column  18, rpt.cust_code,
                column  29, rpt.po_no;
                let scratch = rpt.terms_desc[1,12]
                let x = 78 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
            print

        page trailer
            if after_group is null 
            then 
                let after_group = false
            end if
            if after_group
            then
                let after_group = false
            else
                let last_trlr.sales_tmp = rpt.sales_tmp
                let last_trlr.inv_note = rpt.inv_note
                let last_trlr.misc_tmp = rpt.misc_tmp
                let last_trlr.tax_tmp = rpt.tax_tmp
                let last_trlr.frght_tmp = rpt.frght_tmp
                let last_trlr.ar_tmp = rpt.ar_tmp
            end if
            print
                ;
                let scratch = last_trlr.sales_tmp using "---,---,---.&&"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   3, last_trlr.inv_note
            print
                ;
                let scratch = last_trlr.misc_tmp using "---,---,---.&&"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                ;
                let scratch = last_trlr.tax_tmp using "---,---,---.&&"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                ;
                let scratch = last_trlr.frght_tmp using "---,---,---.&&"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                ;
                let scratch = last_trlr.ar_tmp using "---,---,---.&&"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
            print

        before group of rpt.doc_no
            skip to top of page

        on every row
            print
                column   1, rpt.char_qty clipped,
                            " ", rpt.pack,
                column  20, rpt.item_no,
                column  33, rpt.description,
                column  60, rpt.price using "####.##";
                let scratch = rpt.extension using "---,---,---.&&"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        after group of rpt.doc_no
            let after_group = true
            let last_trlr.sales_tmp = rpt.sales_tmp
            let last_trlr.inv_note = rpt.inv_note
            let last_trlr.misc_tmp = rpt.misc_tmp
            let last_trlr.tax_tmp = rpt.tax_tmp
            let last_trlr.frght_tmp = rpt.frght_tmp
            let last_trlr.ar_tmp = rpt.ar_tmp
        
end report
# report1()

