#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_statmt.4gs/midlevel.4gl  1.2  Delta: 12/1/89
#####################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    let ct.sel_join = "strcustr.acct_bal != 0"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    define
        cycle smallint

    call sel_wind()
    display " or press [ENTER] for all customer statements.  " at 4,2
    prompt "  Enter the Statement Cycle Number: " for cycle
    if int_flag != 0
    then
        let int_flag = 0
        exit program(1)
    end if
    let status = 1
    whenever error continue
    while status != 0
        let status = 0
        display " Print statements through the statement date.   " at 4,2
        prompt "  Enter the Statement Date: " for entry_date
    end while
    whenever error call error_handler
    close window selwin
    if int_flag != 0
    then
        let int_flag = 0
        exit program(1)
    end if
    if cycle is null
    then
        let ct.sel_filter = "1=1"
    else
        let ct.sel_filter = "strcustr.stmt_cycle = ", cycle using "<<<<"
    end if
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "strcustr.cust_code"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from strcustr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    whenever error continue
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "strcustr.bus_name, ",
            "strcustr.address1, ",
            "strcustr.address2, ",
            "strcustr.city, ",
            "strcustr.state, ",
            "strcustr.zip, ",
            "strcustr.ar_type, ",
            "strcustr.stmt_cycle, ",
            "strcustr.stmt_date, ",
            "strcustr.stmt_amount, ",
            "strcustr.acct_bal, ",
            "strcustr.on_acct_amt, ",
            "strcustr.country, ",
            "strcustr.cust_code ",
        "from strcustr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    whenever error continue
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    whenever error call error_handler
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.bus_name = curs_next.bus_name
    let curs.address1 = curs_next.address1
    let curs.address2 = curs_next.address2
    let curs.city = curs_next.city
    let curs.state = curs_next.state
    let curs.zip = curs_next.zip
    let curs.ar_type = curs_next.ar_type
    let curs.stmt_cycle = curs_next.stmt_cycle
    let curs.stmt_date = curs_next.stmt_date
    let curs.stmt_amount = curs_next.stmt_amount
    let curs.acct_bal = curs_next.acct_bal
    let curs.on_acct_amt = curs_next.on_acct_amt
    let curs.country = curs_next.country
    let curs.cust_code = curs_next.cust_code
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.cust_code = curs_next.cust_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("cust_code")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.cust_code = curs_next.cust_code
    then else
        call after_group("cust_code")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Customer Statements"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "1"
    let ct.allow_int = "Y"
end function
# ml_defaults()

