##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_statmt.4gs/report.4gl  1.6  Last Delta: 4/24/90
##############################################################################

##############################################################################
# This report format is designed to fit on form number 091326 from
# Deluxe Computer Forms (phone 1-800-328-0304).  Use FourGen Accounting
# code C06798 when ordering.  The report format designed to fit on
# form number 091453 can be found in report2.4gl.
##############################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            bus_name like strcustr.bus_name,
            address1 like strcustr.address1,
            address2 like strcustr.address2,
            city like strcustr.city,
            state like strcustr.state,
            zip like strcustr.zip,
            ar_type like strcustr.ar_type,
            stmt_cycle like strcustr.stmt_cycle,
            stmt_date like strcustr.stmt_date,
            stmt_amount like strcustr.stmt_amount,
            acct_bal like strcustr.acct_bal,
            on_acct_amt like strcustr.on_acct_amt,
            csz char(40),
            country like strcustr.country,
            cust_code like strcustr.cust_code,
            act_date char(8),
            code1 char(2),
            ref1 char(7),
            chgs char(11),
            crdt char(11),
            bal char(11),
            code2 char(2),
            ref2 char(7),
            amt char(11),
            coment char(30),
            plspay char(11)
        end record,
        last_trlr record
            coment char(30),
            plspay char(11)
        end record,
        after_group smallint,       # true if after group has just been done
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        first_group char(1),        # null if first group
        counter     smallint,       # counter
        x           smallint        # working number

    output
        top margin     11
        bottom margin  3
        left margin    0
        right margin   100
        page length    51

    order external by rpt.cust_code

    format

        first page header
            let after_group = false

        page trailer
            if after_group
            then
                let after_group = false
            else
                let last_trlr.coment = rpt.coment
                let last_trlr.plspay = rpt.plspay
            end if
            print
            print
                column   2, last_trlr.coment,
                column  49, last_trlr.plspay,
                column  74, last_trlr.plspay

        before group of rpt.cust_code
            skip to top of page
            let counter = 0
            print
                column   9, rpt.bus_name
            print
                column   9, rpt.address1,
                column  52, rpt.cust_code,
                column  63, rpt.bus_name
            print
                column   9, rpt.address2
            print
                column   9, rpt.csz
            print
                column   9, rpt.country,
                column  52, rpt.stmt_date,
                column  63, rpt.stmt_date,
                column  81, rpt.cust_code
            print
            print
            print
            print
            print
        on every row
            # for every other page, first print 10 extra lines to match bf group
            if (counter != 0) and ((counter mod 25)) = 0 
            then
                print
                print
                print
                print
                print
                print
                print
                print
                print
                print
            end if
            let counter = counter + 1
            print
                column   3, rpt.act_date,
                column  12, rpt.code1,
                column  15, rpt.ref1,
                column  22, rpt.chgs,
                column  34, rpt.crdt,
                column  49, rpt.bal,
                column  62, rpt.ref2,
                column  70, rpt.code2,
                column  74, rpt.amt

        after group of rpt.cust_code
            if (counter mod 25) != 0  # top of page is cause by after group.
            then
              let last_trlr.coment = rpt.coment
              let last_trlr.plspay = rpt.plspay
              let after_group = true
            end if


end report
# report1()

